#include <WiFlyHQ.h>
#include <ArdOSCForWiFlyHQ.h>

WiFly wifly;
OSCServer server(&wifly);

int EnA = 10;
int ln1 = 8;
int ln2 = 9;
int EnB = 11;
int ln3 = 12;
int ln4 = 13;


void setup()
{ 
  Serial.begin(115200);

  pinMode(8,OUTPUT);
  pinMode(9,OUTPUT);
  pinMode(10,OUTPUT);
  pinMode(11,OUTPUT);
  pinMode(12,OUTPUT);
  pinMode(13,OUTPUT);
  
  //use the convenient setup. Replace <HardwareSerial> by <SoftwareSerial> if you use one.
  wifly.setupForUDP<HardwareSerial>(
    &Serial3,   //the serial you want to use (this can also be a software serial)
    115200, // if you use a hardware serial, I would recommend the full 115200. This does not work with a software serial.
    true,	// should we try some other baudrates if the currently selected one fails?
    "wally",  //Your Wifi Name (SSID)
    "robomint", //Your Wifi Password 
    "FrankRobory",                 // Device name for identification in the network
    "192.168.0.100",         // IP Adress of the Wifly. if 0 (without quotes), it will use dhcp to get an ip
    8000,                    // WiFly receive port
    "255.255.255.255",       // Where to send outgoing Osc messages. "255.255.255.255" will send to all hosts in the subnet
    8001,                     // outgoing port
    true	// show debug information on Serial
  );
  wifly.printStatusInfo(); //print some debug information 

   // Register a callback fuction of the LED fading.
   // When a message is with the adress "/ard/ledFade" is received, "setLedFade" will be invoked.
   //server.addCallback("/rechts",&Rechts);
   //server.addCallback("/stop",&Stopp);
   server.addCallback("/vorwaertsLinksTor",&VorwartsLinksTor);
   server.addCallback("/vorwaertsRechtsTor",&VorwartsRechtsTor);
   server.addCallback("/vorwaertsLinksBall",&VorwartsLinksBall);
   server.addCallback("/vorwaertsRechtsBall",&VorwartsRechtsBall);
   server.addCallback("/stopp",&Stopp);
}


void loop()
{
	//check for new incoming messages. If a message with a registered adress is recieved, the callback function will be invoked.
  if(server.availableCheck(2)>0)
  {  
    //debugoutln("alive!"); //callback after process
  }
}

void VorwartsRechtsBall(OSCMessage *_mes){
  
  float v1=_mes->getArgFloat(0);
  float v2=_mes->getArgFloat(1);
  
  analogWrite(EnA,v1);
  //Rechts
  digitalWrite(ln1, HIGH);
  digitalWrite(ln2, LOW);
  
  analogWrite(EnB,v2);
   //Links
  digitalWrite(ln3, HIGH);
  digitalWrite(ln4, LOW);
  
  Serial.print(v1);
  Serial.print("   ");
  Serial.println(v2);
}

void VorwartsLinksBall(OSCMessage *_mes){
  
  float v1=_mes->getArgFloat(0);
  float v2=_mes->getArgFloat(1);
  
  analogWrite(EnA,v2);
  //Rechts
  digitalWrite(ln1, HIGH);
  digitalWrite(ln2, LOW);
  
  analogWrite(EnB,v1);
   //Links
  digitalWrite(ln3, HIGH);
  digitalWrite(ln4, LOW);
  
  Serial.print(v1);
  Serial.print("   ");
  Serial.println(v2);
}

void VorwartsRechtsTor(OSCMessage *_mes){
  
  float v3=_mes->getArgFloat(0);
  float v4=_mes->getArgFloat(1);
  
  analogWrite(EnA,v3);
  //Rechts
  digitalWrite(ln1, HIGH);
  digitalWrite(ln2, LOW);
  
  analogWrite(EnB,v4);
   //Links
  digitalWrite(ln3, HIGH);
  digitalWrite(ln4, LOW);
  
  Serial.print(v3);
  Serial.print("   ");
  Serial.println(v4);
}

void VorwartsLinksTor(OSCMessage *_mes){
  
  float v3=_mes->getArgFloat(0);
  float v4=_mes->getArgFloat(1);
  
  analogWrite(EnA,v4);
  //Rechts
  digitalWrite(ln1, HIGH);
  digitalWrite(ln2, LOW);
  
  analogWrite(EnB,v3);
   //Links
  digitalWrite(ln3, HIGH);
  digitalWrite(ln4, LOW);
  
  Serial.print(v3);
  Serial.print("   ");
  Serial.println(v4);
}

void Stopp(OSCMessage *_mes){
  
  digitalWrite(EnA,LOW);
  digitalWrite(ln1,LOW);
  digitalWrite(ln2,LOW);
  
  digitalWrite(EnB,LOW);
  digitalWrite(ln3,LOW);
  digitalWrite(ln4,LOW);
}
